// C Source File
// Created 02/13/2001; 23:59:18 PM
//Sample TSR by Greg Dietsche - Last Modification: 10/22/2002

//no need for exit or atexit
 #define NO_EXIT_SUPPORT

//TODO: You Should Set MIN_AMS, and uncomment NO_AMS_CHECK
//If your code will not run on all available AMS versions
//#define MIN_AMS 101
 #define NO_AMS_CHECK

//Usually this results in smaller code, OPTIMIZE_ROM_CALLS also makes calling rom functions faster
//than they would be normally	
	#define OPTIMIZE_ROM_CALLS
	
//TODO: Do you need to have TIGCC detect the calc type?
//For Sample TSR, NO_CALC_DETECT will result in smaller code
//You should comment this out to see if smaller code is produced in your own projects...
//Often times, undefining (commenting out) NO_CALC_DETECT will result in
//smaller code if you use the so-called psuedo constants such as KEY_UP in compat.h
	#define NO_CALC_DETECT

//TODO: Select the calculators that you are compiling for...
 #define USE_TI89
 #define USE_TI92PLUS
 #define USE_V200

#define fatal(s) {ST_showHelp(s);return;}

#include <tigcclib.h>			//Include All Header Files
#include "h220xTSR.h"		 //Kevin Kofler's hw2 ams2 tsr support
#include "array.h"			//The pre-compiled EVENT HOOK
//TODO: Add your own includes, and other stuff that should have a global scope here

//This Code needs TIGCC 0.94 beta 19 at the very least to function properly
#if __TIGCC__==0 && __TIGCC_MINOR__< 94 && __TIGCC_BETA__ < 19
	#warning Sample TSR - Old TIGCC Version -- Check tigcc.ticalc.org for updates
#endif

// Main Function
void _main(void)
{
	volatile HANDLE tsrHandle; 		 //Handle of allocated mem for the Hook
	char		*pTsr;	 							//a pointer to the actual mem for the Hook
	void 		*pHook=EV_hook-16;	 //points to where evHk should be in an installed hook
		
/////////////////////////////////////////
// Program independent error checking	//
///////////////////////////////////////

	//see if the hook has already been installed
		if(EV_hook)
			while(pHook)
			{
			//This code essentially says if(memcmp(tsr,pHook,4))
			//where char tsrsig[4]={'e','v','H','k'}; 1785
			//0x6576486B==#'evHk'
				if(0x6576486B!=*(unsigned long*)pHook)
					break;//the installed hook does not follow the convention, so no more checking can be done
					
			//Already installed
				if(!memcmp(pHook,tsr,12))
					fatal("Already Installed!");
			
			//Get the address for the next hook...
				(unsigned long)pHook=*(unsigned long*)(pHook+12)-16;
			}
	
//TODO: add your own code here... ie handle parameters, and do other stuff that should be
//done before your TSR Event Hook is installed

///////////////////////////////////
// End Error checking/handling	//
/////////////////////////////////

	//sort of like a call to a permanent version of enter_ghost_space();
		if(!h220xTSR())
			fatal("Low RAM!");
			
	//allocate RAM for the Event Hook
		if(!(tsrHandle=HeapAllocHigh(sizeof(tsr))))
			fatal("Low RAM!");

	//get a pointer to the actual mem and make it point in the "ghost space"
	//ghost space is essentially a shadow of regular ram which is not protected very
	//well by the hardware... subtract 0x40000 to get the real address
		pTsr=HeapDeref(tsrHandle)+0x40000;

	//Copy The tsr array to its new location
		memcpy(pTsr,tsr,sizeof(tsr));
		
	//Save the Old tsr hook's address for the uninstall prog and for this hook to call
		*(unsigned long*)&pTsr[12]=(unsigned long)EV_hook;
		
		EX_patch(pTsr,pTsr+sizeof(tsr));
		ASM_fastcall(&pTsr[16]);
		EV_hook=(EVENT_HANDLER)&pTsr[16];

	//TODO: You should change or remove this line as necessary
		fatal("SYSMANAGER memory protector Installed");
}
